#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3000eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 3000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight30004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight30004xi = {
                1:'-1013x-371y-2799z',
                2:'-1018x-903y-2673z',
                3:'-1058x-326y-2788z',
                4:'-1083x-2188y-1742z',
                5:'-1084x-1901y-2051z',
                6:'-1084x-865y-2659z',
                7:'-1100x-277y-2777z',
                8:'-112x-1000y-2931z',
                9:'-1133x-2769y-209z',
                10:'-1140x-224y-2765z',
                11:'-1150x-822y-2645z',
                12:'-1178x-168y-2753z',
                13:'-118x-517y-2952z',
                14:'-1193x-1859y-2029z',
                15:'-1205x-2143y-1718z',
                16:'-1212x-108y-2741z',
                17:'-1214x-775y-2631z',
                18:'-1275x-724y-2616z',
                19:'-1277x-2708y-179z',
                20:'-1301x-1810y-2006z',
                21:'-1325x-2091y-1693z',
                22:'-1335x-667y-2602z',
                23:'-1392x-607y-2586z',
                24:'-1406x-1755y-1984z',
                25:'-1418x-2639y-149z',
                26:'-1442x-2033y-1668z',
                27:'-1446x-542y-2571z',
                28:'-1497x-474y-2556z',
                29:'-1509x-1694y-1961z',
                30:'-153x-539y-2947z',
                31:'-1544x-401y-2540z',
                32:'-1555x-2562y-119z',
                33:'-1557x-1968y-1643z',
                34:'-1610x-1627y-1939z',
                35:'-164x-989y-2827z',
                36:'-1668x-1896y-1618z',
                37:'-1687x-2478y-89z',
                38:'-1707x-1553y-1916z',
                39:'-1776x-1817y-1593z',
                40:'-1801x-1474y-1892z',
                41:'-1815x-2387y-59z',
                42:'-1881x-1732y-1567z',
                43:'-1890x-1389y-1869z',
                44:'-190x-558y-2941z',
                45:'-1938x-2289y-29z',
                46:'-1976x-1298y-1845z',
                47:'-1981x-1642y-1542z',
                48:'-200x-2008y-2219z',
                49:'-2055x-2184y0z',
                50:'-2057x-1202y-1822z',
                51:'-2076x-1545y-1516z',
                52:'-2133x-1101y-1798z',
                53:'-215x-2303y-1909z',
                54:'-2167x-1442y-1490z',
                55:'-2204x-995y-1774z',
                56:'-220x-2966y-388z',
                57:'-221x-1007y-2817z',
                58:'-2252x-1334y-1464z',
                59:'-2270x-885y-1749z',
                60:'-230x-574y-2935z',
                61:'-2330x-770y-1725z',
                62:'-2332x-1221y-1437z',
                63:'-2383x-652y-1700z',
                64:'-2405x-1104y-1411z',
                65:'-2431x-530y-1676z',
                66:'-2471x-404y-1651z',
                67:'-2473x-981y-1384z',
                68:'-2505x-276y-1625z',
                69:'-2534x-855y-1358z',
                70:'-2588x-725y-1331z',
                71:'-2635x-591y-1304z',
                72:'-272x-588y-2928z',
                73:'-281x-1021y-2806z',
                74:'-29x-441y-2967z',
                75:'-308x-2017y-2199z',
                76:'-316x-599y-2922z',
                77:'-338x-2308y-1886z',
                78:'-343x-1031y-2795z',
                79:'-362x-607y-2915z',
                80:'-376x-2954y-358z',
                81:'-407x-1038y-2784z',
                82:'-410x-611y-2908z',
                83:'-418x-2019y-2178z',
                84:'-459x-612y-2900z',
                85:'-462x-2305y-1862z',
                86:'-472x-1040y-2773z',
                87:'-509x-609y-2892z',
                88:'-528x-2015y-2157z',
                89:'-530x-2934y-328z',
                90:'-539x-1039y-2762z',
                91:'-560x-603y-2884z',
                92:'-56x-468y-2962z',
                93:'-587x-2296y-1839z',
                94:'-606x-1033y-2750z',
                95:'-611x-593y-2876z',
                96:'-640x-2005y-2136z',
                97:'-65x-2969y-418z',
                98:'-663x-579y-2867z',
                99:'-675x-1023y-2738z',
                100:'-684x-2905y-299z',
                101:'-6x-412y-2971z',
                102:'-712x-2279y-1815z',
                103:'-715x-561y-2858z',
                104:'-744x-1008y-2725z',
                105:'-751x-1989y-2115z',
                106:'-767x-539y-2849z',
                107:'-813x-989y-2713z',
                108:'-818x-514y-2840z',
                109:'-836x-2256y-1791z',
                110:'-836x-2868y-269z',
                111:'-85x-494y-2957z',
                112:'-863x-1966y-2094z',
                113:'-868x-484y-2830z',
                114:'-882x-965y-2700z',
                115:'-918x-450y-2820z',
                116:'-94x-1993y-2239z',
                117:'-94x-2292y-1932z',
                118:'-950x-936y-2686z',
                119:'-960x-2225y-1767z',
                120:'-966x-412y-2809z',
                121:'-974x-1937y-2072z',
                122:'-986x-2823y-239z'}         

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3000eight4xi" usage = "target function for charge3000eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3000eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3000EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3000EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3000EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3000EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3000EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight30004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3000EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3000EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3000EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight30004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight30004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3000EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3000EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3000EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3000eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  